//
// AG_AT.mq4               TD_DeMark_3_1_mod ( 11,9,10  16)
//    .
//         AutoGraf 4
//  , , sk@autograf.dp.ua, ICQ 64015987, http://autograf.dp.ua
//
//     .    .. 
// ..     .
// 0 
#property library   
 
#import "AG_Lib.ex4"
   int AG_Magic_Number();                          //  MN 
   int AG_Message(string& Message[], string _Text);//     Message[]
                          //    -    Manager[][]:
   int AG_Set_Instr(double& Manager[][], int ii, double v1, double v2, double v3,
                    double v4, double v5, double v6, int io , int ih); 
   int AG_Delete_Instr(double&Manager[][], int ii, int io,int ih);// 
#import "AG_Trade_Criterion_DrSh.ex4"
   int AG_Trade_Criterion_DrSh();                  // - . .  3
#import
// 1 
int AG_AT(int Parol_AT, double Order[][], string Object[], double Instrument[][][][], 
          int Ddraw_Object[][], double& Tuning[], double& Manager[][], string& Message[])
   {    
//================================================================================== 2 ==
   static bool Instr_16 = false;//  16   ()
   static int Count = 0;                           //  
   int MN;                // MagicNumber    - AG_Magic_Number()
   int Ticket;                                     //  
   string Comm = "AG_AT";                          //  ( "AG_AT")
   double Price_Opn;                               //   
   int SL = 45;                                    // StopLoss  
   double TakeProfit;                              // TakeProfit
   int Tip_Ord;                                    //  
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   double Lot= NormalizeDouble(Tuning[1],2);       //  
//---------------------------------------------------------------------------------- 3 --
   if (Count==0)              //        
      {                       //   ( 62 ):
      AG_Message(Message, "     . AG_Trade_Criterion_DrSh");
      Count++;                //    
      
      Tuning[1] = 0;          // 0.0 ,      AutoGraf..
      int Per   = 5;         // ..    % ( 5%)  
      Tuning[2] = Per;        //  % 
      AG_Message(Message,"   .");//   (.62 .)
      return(1);              //    
      }
                              //  ,    AG_AT  ..
                              // ..   AutoGraf,    AG_ind..
                              // ..     .
//================================================================================== 4 ==
   string Sym = Symbol();                                //  

   double D_Low  = iLow  (Sym, 1440, 1);                                //  
   double D_High = iHigh (Sym, 1440, 1);                                //  
   double D_Cls  = iClose(Sym, 1440, 1);                                //  
   double D3 = 0.2750;                                                  // ?
                                                         //   
   double H3 = D_Cls + (D_High - D_Low)*D3;                             //  .
   double L3 = D_Cls - (D_High - D_Low)*D3;                             //  .
//---------------------------------------------------------------------------------- 5 --
   int Crit = AG_Trade_Criterion_DrSh(); //     
   int Total_Ord = NormalizeDouble(Order[0][0],0);//     ( 1) 
   int STOPLEVEL = MarketInfo(Sym,MODE_STOPLEVEL);//    
   double Middle = NormalizeDouble((H3+L3)/2,Digits);//   .16

   if (Total_Ord==0 && Crit == 10)//    +   Buy
      {
      AG_Message(Message, ":    Buy.");//  
      MN = AG_Magic_Number(); //  MagicNumber ()
      TakeProfit = H3;    // TakeProfit =  
      if(NormalizeDouble(TakeProfit-Ask,Digits)< NormalizeDouble(STOPLEVEL*Point,Digits))
         TakeProfit = NormalizeDouble(Ask + STOPLEVEL*Point,Digits);
                              //   Buy:
      Ticket = OrderSend( Symbol(),OP_BUY,Lot,Ask,2,Bid-SL*Point,TakeProfit,Comm,MN); 
      return(1);              //     AG   
      }
      
   if (Total_Ord==0 && Crit == 20)//   +   Sell
      {
      AG_Message(Message, ":    Sell.");//  
      MN = AG_Magic_Number(); //  MagicNumber ()
      TakeProfit = L3;        // TakeProfit =  
      if(NormalizeDouble(Bid-TakeProfit,Digits)< NormalizeDouble(STOPLEVEL*Point,Digits))
         TakeProfit = NormalizeDouble(Bid - STOPLEVEL*Point,Digits);
                              //   Sell
      Ticket = OrderSend( Symbol(),OP_SELL,Lot,Bid,2,Ask+SL*Point,TakeProfit,Comm,MN); 
      return(1);              //     AG   
      }
//================================================================================== 6 ==
   if (Total_Ord == 0)
      {
      Instr_16 = true;        //  16   ( )
      return(1);              //  
      }
   for (int i=1; i<=Total_Ord; i++)             //    
      {
      Tip_Ord= NormalizeDouble(Order[i][6],0);  //   
      Ticket = NormalizeDouble(Order[i][4],0);  //  
      double Lot_16 = NormalizeDouble(Order[i][5]/2,1);//   .. 
                                                // ..( ,   )
//---------------------------------------------------------------------------------- 7 --
      if (Tip_Ord == 0)                         //    Buy
         {              //  . __  Buy  :
         if( NormalizeDouble(Instrument[1][1][16][0],0)==0.0 && Instr_16 == true)
            {                          
                                                //  .16 __
            AG_Set_Instr(Manager, 16, 25, Middle, 0, 0, 0, Lot_16, Ticket, 1);
            // 16 =       http://autograf.dp.ua/Pages/2/24/2416.htm
            // 25 =   (  )
            // Middle =   
            // 0  =   (  ,   AutoGraf) 
            // 0  =  
            // 0  =  
            // Lot_16 =  ,  
            // Ticket  =  
            // 1  =    (OR=1)
            Instr_16 = false;//         
            AG_Message(Message, "  Sell " + Ticket+ " ");//( 62)
            AG_Message(Message, "  __.");            
            }
//.................................................................................. 8 ..
         if( NormalizeDouble(Instrument[1][1][4][0],0)==0.0 )              
            // 1  =  
            // 1  =    (OR), _0_Buy   ..
            //                                  .. StopLoss,    
            // 4  =   _0_Buy
            // 0  =   
            // 0.0=    (1.0 = )
            {
                                 //   4 _0_Buy  
            if (NormalizeDouble(Order[i][2],Digits)< NormalizeDouble(Order[i][1],Digits))
               {                                //  StopLoss   
               AG_Set_Instr(Manager, 4, 33, Middle, 0, 5, 0, 0, Ticket, 1); 
               // 4  =  
               // 33 =  
               // Middle =     ( 20  Buy)
               // 0  =    (  AutoGraf    )
               // 5  =        (  ),
               //                  ..    StopLoss.
               // 0  =  
               // 0  =  
               // Ticket  =  
               // 1  =    (OR=1)
               AG_Message(Message, " StopLoss Buy " + Ticket+ " ");//( 62)
               AG_Message(Message, "  _0_Buy.");// 
               }
            }
         }      
//---------------------------------------------------------------------------------- 9 --
      if (Tip_Ord == 1)                         //    Sell
         {                       //  . __  Sell  :
         if( NormalizeDouble(Instrument[1][1][16][0],0)==0.0 && Instr_16 == true)
            {                          
                                             //  .16 __
            AG_Set_Instr(Manager, 16, 25, Middle, 0, 0, 0, Lot_16, Ticket, 1);
            Instr_16 = false;//         
            AG_Message(Message, "  Sell " + Ticket+ " ");//( 62)
            AG_Message(Message, "  __.");
            }
//................................................................................. 10 ..
         if( NormalizeDouble(Instrument[1][1][5][0],0)==0.0 )
            {
            if (NormalizeDouble(Order[i][2],Digits)> NormalizeDouble(Order[i][1],Digits))
               {                                //  StopLoss                                        
                                 //   5 _0_Sell  
               AG_Set_Instr(Manager, 5, 33, Middle, 0, 5, 0, 0, Ticket, 1);
               AG_Message(Message, " StopLoss Sell " + Ticket+ " ");//( 62)
               AG_Message(Message, "  _0_Sell.");// 
               }
            }
         }      
      }
//================================================================================= 11 ==
   return(1);           //  
   }
//    12 